package com.zt.plat.module.erp.service.erp;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.pojo.vo.BatchDeleteReqVO;
import com.zt.plat.module.base.api.departmentmaterial.dto.DepartmentMaterialPageReqDTO;
import com.zt.plat.module.base.api.materialinfomation.dto.MaterialInfomationPageReqDTO;
import com.zt.plat.module.erp.api.dto.ErpMaterialDTO;
import com.zt.plat.module.erp.controller.admin.erp.vo.*;
import com.zt.plat.module.erp.dal.dataobject.erp.ErpMaterialDO;
import jakarta.validation.Valid;

import java.util.List;

/**
 * ERP物料数据 Service 接口
 *
 * @author 后台管理
 */
public interface ErpMaterialService {

    /**
     * 创建ERP物料数据
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    ErpMaterialRespVO createErpMaterial(@Valid ErpMaterialSaveReqVO createReqVO);

    /**
     * 更新ERP物料数据
     *
     * @param updateReqVO 更新信息
     */
    void updateErpMaterial(@Valid ErpMaterialSaveReqVO updateReqVO);

    /**
     * 删除ERP物料数据
     *
     * @param id 编号
     */
    void deleteErpMaterial(Long id);

    /**
    * 批量删除ERP物料数据
    *
    * @param ids 编号
    */
    void deleteErpMaterialListByIds(List<Long> ids);

    /**
     * 获得ERP物料数据
     *
     * @param id 编号
     * @return ERP物料数据
     */
    ErpMaterialDO getErpMaterial(Long id);

    /**
     * 获得ERP物料数据分页
     *
     * @param pageReqVO 分页查询
     * @return ERP物料数据分页
     */
    PageResult<ErpMaterialDO> getErpMaterialPage(ErpMaterialPageReqVO pageReqVO);

    void callErpRfcInterface();

    PageResult<ErpMaterialRespVO> getErpMaterialPageAndOther(ErpMaterialPageReqVO pageReqVO);

    String getMaterialUnit(String materialNumber);

    List<ErpMaterialRespVO> createErpMaterialCorr(ErpMaterialCorrSaveReqVO  erpMaterialCorrSaveReqVO);

    void deleteErpMaterialCorr(DeleteErpMaterialCorrVO reqVO);

    ErpMaterialDO getErpMaterialById(Long id);

    List<ErpMaterialRespVO> getErpMaterialByMainMaterial(Long mainMaterialId, String companyCode);

    PageResult<ErpMaterialDO>  getErpMaterialByApi(  MaterialInfomationApiVO vo);

    List<ErpMaterialDO> getErpMaterialByMainMaterialByCode(String code,String deptId);

    List <ErpMaterialDO>getErpMaterialByApiByCode(String code,String deptId);

    PageResult<ErpMaterialDO>  getErpProdMaterialByApi(MaterialInfomationApiVO vo);
}